;=======================================================
; Flyin' Mega Mole
; By Erik557
;
; Description: A Mega Mole with fucking wings. Yup, we
; have come this far regarding janky ideas.
; This version emulates the red flying parakoopas, aka
; sprites 0A and 0B.
;
; Uses first extra bit: YES
; When set, it will fly up and down. Else, it will fly
; left ro right
;=======================================================

;======================
; Defines and stuff
;======================

Speeds:              ; cumulative values for X or Y speeds
       db $FF,$01
TargetSpeed:         ; maximum speed before turning
       db $F0,$10

Tilemap:
       db $C6,$C8,$E6,$E8
       db $CA,$CC,$EA,$EC
WingsTiles:
       db $5D,$C6,$5D,$C6
WingProps:
       db $76,$76,$36,$36

;=================================
; INIT and MAIN Wrappers
;=================================

print "INIT ",pc
       JSR SubHorizPos
       TYA
       STA $157C,x
       JSL $01ACF9
       STA $1570,x
       RTL
            
print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR flyinMegaMole
       PLB
       RTL

;========================
; Main routine
;========================

MainReturn:
       RTS

flyinMegaMole:
       JSR Graphics
       LDA $14C8,x
       EOR #$08
       ORA $9D
       BNE MainReturn
       INC $1570,x
       LDA $1570,x
       LSR #2
       AND #$01
       STA $1602,x
       JSL $01801A
       LDA $7FAB10,x
       AND #$04
       BNE .DoneUpdating
.Horz
       JSL $018022
       LDY #$FC
       LDA $1570,x
       AND #$20
       BEQ +
       LDY #$04
+      STY $AA,x
.DoneUpdating
       LDA $1540,x
       BNE .NotChangeYet
       INC $151C,x
       LDA $151C,x
       AND #$03
       BNE .NotChangeYet
.Speed
       LDA $C2,x
       AND #$01
       TAY
       LDA $B6,x
       CLC
       ADC Speeds,y
       STA $AA,x
       STA $B6,x
       CMP TargetSpeed,y
       BNE .NotChangeYet
       INC $C2,x
       LDA #$30
       STA $1540,x
.NotChangeYet
       LDY $157C,x
       LDA $B6,x
       CMP Speeds,y
       BNE +
       TYA
       EOR #$01
       STA $157C,x
+      LDA $7FAB10,x
       AND #$04
       BEQ +
       STZ $1491
+      EOR #$04
       LSR
       TAY
       JSR SubOffScreen

       JSL $018032
       JSL $01A7DC
       BCC .return
       JSR SubVertPos
       LDA $0E
       CMP #$D8
       BPL .hurt
       LDA $7D
       BMI .return
       LDA #$06
       STA $1FE2,x
       LDA #$01
       STA $1471
       STZ $7D
       LDA #$D6
       LDY $187A
       BEQ +
       LDA #$C6
+      CLC
       ADC $D8,x
       STA $96
       LDA $14D4,x
       ADC #$FF
       STA $97
       LDY #$00
       LDA $1491
       BPL +
       DEY
+      CLC
       ADC $94
       STA $94
       TYA
       ADC $95
       STA $95
.return
       RTS

.hurt
       LDA $154C,x
       BNE .return
       JSL $00F5B7
       RTS

;========================
; Graphics routine
;========================

XDisp:
       db $00,$10,$00,$10
       db $10,$00,$10,$00
YDisp:
       db $F0,$F0,$00,$00
WingsSize:
       db $00,$02,$00,$02
WingsXDisp:
       db $02,$FA,$16,$18
WingsYDisp:
       db $FC,$F4,$FC,$F4

Graphics:
       JSR GetDrawInfo

       LDA $1602,x          ;\  tile index for future uses
       STA $02              ;/
       LDA $157C,x          ;\
       ASL                  ; | multiply the direction
       CLC                  ; | add our frame index to index the tables
       ADC $02              ; |
       TAX                  ;/
       LDA $00              ;\
       CLC                  ; | wings x pos
       ADC WingsXDisp,x     ; |
       STA $0300,y          ;/
       LDA $01              ;\
       CLC                  ; | wings y pos
       ADC WingsYDisp,x     ; |
       STA $0301,y          ;/
       LDA WingsTiles,x     ;\  wings tilemap
       STA $0302,y          ;/
       LDA $64              ;\
       ORA WingProps,x      ; | wings properties
       STA $0303,y          ;/
       TYA                  ;\
       LSR #2               ; | index into tilesize
       TAY                  ;/
       LDA WingsSize,x      ;\  variable size, depending on the wing frame
       STA $0460,y          ;/

       LDX $15E9            ;   retrieve index
       LDA $15EA,x          ;\
       CLC                  ; | get new set of oam slots
       ADC #$04             ; |
       TAY                  ;/

       LDA $157C,x
       STA $02
       LDA $1570,x
       LSR #3
       AND #$01
       ASL #2
       STA $03

       LDX #$03
-      PHX
       LDA $02
       BNE +
       INX #4
+      LDA $00
       CLC
       ADC XDisp,x
       STA $0300,y
       LDA $01,s
       TAX
       LDA $01
       CLC
       ADC YDisp,x
       STA $0301,y
       TXA
       CLC
       ADC $03
       TAX
       LDA Tilemap,x
       STA $0302,y
       LDA #$01
       LDX $02
       BNE +
       ORA #$40
+      ORA $64
       STA $0303,y
       PHY
       TYA
       LSR #2
       TAY
       LDA #$02
       STA $0460,y
       PLY       
       PLX
       INY #4
       DEX
       BPL -

       LDX $15E9
       LDY #$FF
       LDA #$04
       JSL $01B7B3
       RTS

;========================
; Misc. subroutines
;========================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  GetDrawInfo:            ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$20
       SEC
       SBC $1A
       STA $00
       CLC
       ADC #$0040
       CMP #$0180
       SEP #$20
       LDA $01
       BEQ +
       LDA #$01
+      STA $15A0,x
       TDC
       ROL A
       STA $15C4,x
       BNE .Invalid
       LDA $14D4,x
       XBA
       LDA $1662,x
       AND #$20
       BEQ .CheckOnce
.CheckTwice
       LDA $D8,x
       REP #$21
       ADC #$001C
       SEC
       SBC $1C
       SEP #$20
       LDA $14D4,x
       XBA
       BEQ .CheckOnce
       LDA #$02
.CheckOnce
       STA $186C,x
       LDA $D8,x
       REP #$21
       ADC #$000C
       SEC
       SBC $1C
       SEP #$21
       SBC #$0C
       STA $01
       XBA
       BEQ .OnScreenY
       INC $186C,x
.OnScreenY
       LDY $15EA,x
       RTS

.Invalid
       PLA
       PLA
       RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  SubOffScreen:           ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       LDA $15A0,x
       ORA $186C,x
       BEQ .Return2
       LDA $167A,x
       AND #$04
       BNE .Return2
       LDA $5B
       LSR A
       BCS .VerticalLevel
       LDA $D8,x
       ADC #$50
       LDA $14D4,x
       ADC #$00
       CMP #$02
       BCS .EraseSprite
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC .AddTable,y
       SEC
       SBC $1A
       CMP .CmpTable,y
.Common
       SEP #$20
       BCC .Return2
.EraseSprite
       LDA $14C8,x
       CMP #$08
       BCC .KillSprite
       LDY $161A,x
       CPY #$FF
       BEQ .KillSprite
       LDA $1938,y
       AND #$FE
       STA $1938,y
.KillSprite
       STZ $14C8,x
.Return2
       RTS

.VerticalLevel
       LDA $13
       LSR A
       BCS .CheckY
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC.w #$0040
       CMP.w #$0280
       BRA .Common
.CheckY
       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       SBC $1C
       CLC
       ADC.w #$0070
       CMP.w #$01D0
       BRA .Common

.AddTable
       dw $0040,$0040,$0010,$0070
       dw $0090,$0050,$0080,$FFC0
.CmpTable
       dw $0170,$01E0,$01B0,$01D0
       dw $0230,$01B0,$0220,$0160

;==================
  SubHorizPos:
;==================

       LDY #$00
       LDA $94
       SEC
       SBC $E4,x
       STA $0F
       LDA $95
       SBC $14E0,x
       BPL $01
       INY
       RTS

;==================
  SubVertPos:
;==================

       LDY #$00
       LDA $96
       SEC
       SBC $D8,x
       STA $0E
       LDA $97
       SBC $14D4,x
       BPL $01
       INY
       RTS

